Subject: Re: [RFC] Option to disable mapping genrtc calls to ppc_md calls

From: Tom Rini <[email-masked]>
Date: Wed, 19 Jan 2005 11:08:42 -0700

On Tue, Jan 18, 2005 at 12:43:12PM -0700, Mark A. Greer wrote:
> Tom Rini wrote:
> 
> >On Tue, Jan 18, 2005 at 11:58:25AM -0700, Mark A. Greer wrote:
> > 
> >
> >>Tom Rini wrote:
> >>
> >>   
> >>
> >>>I think one of us wasn't clear.  I'm not arguing for nuking
> >>>ppc_md.{get,set}_rtc_time(), I'm arguing for nuking
> >>>get_rtc_time()/set_rtc_time() inlines from <asm-ppc/rtc.h> (which are
> >>>used by drivers/char/genrtc.c) in favor of todc_time et al providing the
> >>>functions for genrtc.  So all of the other places we use
> >>>ppc_md.{get,set}_rtc_time() are unchanged.
> >>>     
> >>>
> >>Ahh.  Okay, that's good but it should be done in drivers/rtc or 
> >>something like and not just another arch specific solution.
> >>   
> >>
> >
> >It's not an arch specific solution today.
> >
> 
> Okay, I see what you mean and yes moving that up (or something 
> equivalent) would be a good idea.
> 
> That's not what my patch is about though.  My patch is just so I can 
> provide a generic solution with what is there today.  Its not 
> redesigning anything, its just getting asm-ppc/rtc.h out of the way so I 
> can make my own, generic get_rtc_time(), etc.

I guess the problem I have is you're not providing a generic solution
(it won't work on PPC_MULTIPLATFORM), you're providing a different hook
for your board(s) :)

Taking a look at arch/arm/common/rtctime.c again finally, it solves this
problem rather elegantly.  The board registers with the driver the
rtc_ops to get at the chip.

So until we get around to stealing arch/arm/common/rtctime.c, I'd rather
you used something like:
- arch/ppc/Kconfig (or where ever you add the board bits)
  config PPC_DIFFERENT_GENRTC_HOOKS
  default y if BOARD_A || BOARD_B
- include/asm-ppc/rtc.h : what you had, basically.

-- 
Tom Rini
http://gate.crashing.org/~trini/